#include <bits/stdc++.h>

using namespace std;

#define ll long long

const ll INF = 1e18;
const int maxN = 505;
const int maxM = 100005;
const int ALPH = 26;
const int maxS = 1000005;

vector<string> arr;
vector<ll> wrr;
vector<pair<int, char>> ch[maxN];

int go[maxS][26];
int suff[maxS];
int super_suff[maxS];
int hv[maxS];
bool term[maxS];
ll cost[maxS];
int CNT = 0;

int newVert() {
    for (int c = 0; c < ALPH; c++) go[CNT][c] = -1;
    suff[CNT] = 0;
    super_suff[CNT] = -1;
    cost[CNT] = INF;
    return CNT++;
}

void add(string &s, ll w) {
    int v = 0;
    for (int i = 0; i < s.size(); i++) {
        if (go[v][s[i]] == -1) {
            go[v][s[i]] = newVert();
            hv[go[v][s[i]]] = hv[v] + 1;
        }
        v = go[v][s[i]];
    }
    term[v] = 1;
    cost[v] = min(cost[v], w);
}

void build() {
    for (int c = 0; c < ALPH; c++) {
        if (go[0][c] == -1) go[0][c] = 0;
    }

    queue<int> q;
    for (int c = 0; c < ALPH; c++) {
        if (go[0][c] != 0) q.push(go[0][c]);
    }

    while (q.size() > 0) {
        int v = q.front(); q.pop();
        for (int c = 0; c < ALPH; c++) {
            if (go[v][c] != -1) q.push(go[v][c]);
        }

        for (int c = 0; c < ALPH; c++) {
            if (go[v][c] != -1) {
                suff[go[v][c]] = go[suff[v]][c];
                continue;
            }

            go[v][c] = go[suff[v]][c];
        }

        if (term[suff[v]]) super_suff[v] = suff[v];
        else super_suff[v] = super_suff[suff[v]];
    }
}

ll dp[maxN][maxN];

void dfs(int v, int cur) {
    //cout << v + 1 << " " << cur + 1 << endl;

    for (int h = 0; h < maxN; h++) dp[v][h] = INF;

    for (auto p : ch[v]) {
        dfs(p.first, go[cur][p.second]);
    }

    ll sum = 0;
    for (auto p : ch[v]) sum += dp[p.first][1];
    int lcur = cur;
    while (lcur != -1) {
        dp[v][hv[lcur]] = sum + cost[lcur];
        lcur = super_suff[lcur];
    }

    for (int h = 0; h < maxN - 1; h++) {
        for (int i = 0; i < ch[v].size(); i++) {
            ll sum = 0;
            for (int j = 0; j < ch[v].size(); j++) {
                if (j != i) sum += dp[ch[v][j].first][1];
            }
            sum += dp[ch[v][i].first][h + 1];

            dp[v][h] = min(dp[v][h], sum);
        }
    }

    for (int h = maxN - 2; h >= 0; h--) {
        dp[v][h] = min(dp[v][h], dp[v][h + 1]);
    }
}

int main() {
    //freopen("in.in", "r", stdin);

    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int n, m, t;
    cin >> n >> m >> t;

    for (int i = 1; i < n; i++) {
        int p;
        char c;
        cin >> p >> c;
        p--;

        ch[p].push_back({i, c - 'a'});
    }

    for (int i = 0; i < m; i++) {
        string s;
        ll w;
        cin >> w >> s;

        if (s.size() <= n) {
            for (int k = 0; k < s.size(); k++) s[k] -= 'a';

            arr.push_back(s);
            wrr.push_back(w);
        }
    }
    m = arr.size();

    newVert();
    for (int i = 0; i < m; i++) {
        add(arr[i], wrr[i]);
    }
    build();

    /*
    for (int i = 0; i < CNT; i++) {
        cout << i + 1 << " " << term[i] << " " << super_suff[i] << " " << hv[i] << " " << cost[i] << ": " << endl;
        for (int c = 0; c < 2; c++) {
            cout << (char)(c + 'a') << " -> " << go[i][c] + 1 << endl;
        }
    }
    //*/

    dfs(0, 0);
    /*for (int i = 0; i < n; i++) {
            cout << i + 1 << ": ";
        for (int h = 0; h <= 3; h++) cout << dp[i][h] << " ";
        cout << endl;
    }*/
    cout << dp[0][0] << endl;


    return 0;
}
