#include <bits/stdc++.h>

using namespace std;

#define ll long long

const ll INF = 1e18;
const int maxN = 100005;

struct Seg {
    int l, r;
    int c;
};

vector<Seg> arr;

void solve(int l, int r, vector<Seg>& arr, map<int, int>& cnt) {
    if (arr.size() == 1) {
        cnt[arr[0].c] = 1;
        return;
    }

    int m = (l + r) / 2;

    vector<Seg> arr1, arr2;
    for (int i = 0; i < arr.size(); i++) {
        if (arr[i].l < m) arr1.push_back(arr[i]);
        if (arr[i].r > m) arr2.push_back(arr[i]);
    }

    map<int, int> cnt1, cnt2;
    solve(l, m, arr1, cnt1);
    solve(m, r, arr2, cnt2);

    if (cnt1.size() > cnt2.size()) {
        cnt1.swap(cnt2);
    }

    for (auto p : cnt1) {
        cnt2[p.first] += p.second;
    }
    cnt.swap(cnt2);

    int best = cnt.begin()->first;
    for (auto p : cnt) {
        if (p.second > cnt[best]) best = p.first;
    }

    cnt[best] = 1;
}

int main() {
    //freopen("in.in", "r", stdin);

    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int k, n, m;
    cin >> k >> n >> m;

    int lst = 0;
    for (int i = 0; i < n; i++) {
        Seg seg;
        int len, c;
        cin >> len >> c;
        seg.l = lst;
        seg.r = lst + len;
        seg.c = c;
        arr.push_back(seg);

        lst += len;
    }

    map<int, int> res;
    solve(0, (1<<k), arr, res);
    int sum = 0;
    for (auto p : res) sum += p.second;
    cout << sum << endl;

    return 0;
}
