#include <bits/stdc++.h>

using namespace std;

#define ll long long

const int INF = 1e9;
const int maxN = 100005;

struct Seg {
    int l, r;
    int c;
};

vector<Seg> arr;

void solve(int l, int r, vector<Seg>& arr, map<int, int>& ans) {
    if (arr.size() == 1) {
        ans[0] = 1;
        ans[arr[0].c] = 0;
        return;
    }

    int m = (l + r) / 2;

    vector<Seg> arr1, arr2;
    for (int i = 0; i < arr.size(); i++) {
        if (arr[i].l < m) arr1.push_back(arr[i]);
        if (arr[i].r > m) arr2.push_back(arr[i]);
    }

    map<int, int> ansl, ansr;

    solve(l, m, arr1, ansl);
    solve(m, r, arr2, ansr);

    int best = INF;
    for (Seg seg : arr) {
        if (ansl.count(seg.c) && ansr.count(seg.c)) {
            ans[seg.c] = ansl[seg.c] + ansr[seg.c];
        }
        else if (ansl.count(seg.c)) {
            ans[seg.c] = ansl[seg.c] + ansr[0];
        }
        else {
            ans[seg.c] = ansl[0] + ansr[seg.c];
        }
        best = min(best, ans[seg.c]);
    }

    ans[0] = min(ansl[0] + ansr[0], best + 1);
    for (Seg seg : arr) {
        ans[seg.c] = min(ans[seg.c], best + 1);
    }
}

int main() {
    //freopen("in.in", "r", stdin);

    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int k, n, m;
    cin >> k >> n >> m;

    int lst = 0;
    for (int i = 0; i < n; i++) {
        Seg seg;
        int len, c;
        cin >> len >> c;
        seg.l = lst;
        seg.r = lst + len;
        seg.c = c;
        arr.push_back(seg);

        lst += len;
    }

    map<int, int> ans;
    solve(0, (1<<k), arr, ans);

    cout << ans[0] << endl;

    return 0;
}
