#include <bits/stdc++.h>

using namespace std;

#define ll long long

const int INF = 1e9;
const int maxN = 100005;

struct Seg {
    int l, r;
    int c;
};

vector<Seg> arr;

void solve(int l, int r, vector<Seg>& arr, vector<int>& ans) {
    //cout << "1 " << l << " " << r << endl;
    if (arr.size() == 1) {
        ans.resize(2);
        ans[0] = 1;
        ans[1] = 0;
        return;
    }

    int m = (l + r) / 2;

    //cout << "2 " << l << " " << r << endl;

    vector<Seg> arr1, arr2;

    vector<int> comp(arr.size());
    comp[0] = 1;
    for (int i = 1; i < arr.size(); i++) {
        comp[i] = comp[i - 1] + (arr[i].c != arr[i - 1].c);
    }
    /*cout << "----------------- " << l << " " << r << " ------------" << endl;
    for (Seg s : arr) cout << s.c << " ";
    cout << endl;
    for (int c : comp) cout << c << " ";
    cout << endl;*/

    vector<bool> usedl(arr.size() + 1);
    vector<bool> usedr(arr.size() + 1);
    vector<int> indl(arr.size() + 1);
    vector<int> indr(arr.size() + 1);

    for (int i = 0; i < arr.size(); i++) {
        if (arr[i].l < m) {
            arr1.push_back(arr[i]);
            usedl[comp[i]] = 1;
            indl[comp[i]] = arr1.size() - 1;
        }
        if (arr[i].r > m) {
            arr2.push_back(arr[i]);
            usedr[comp[i]] = 1;
            indr[comp[i]] = arr2.size() - 1;
        }
    }

    //cout << "3 " << l << " " << r << endl;

    vector<int> comp_l(arr1.size() + 1);
    comp_l[0] = 1;
    for (int i = 1; i < arr1.size(); i++) {
        comp_l[i] = comp_l[i - 1] + (arr1[i].c != arr1[i - 1].c);
    }
    vector<int> compr(arr2.size() + 1);
    compr[0] = 1;
    for (int i = 1; i < arr2.size(); i++) {
        compr[i] = compr[i - 1] + (arr2[i].c != arr2[i - 1].c);
    }

    for (int i = 0; i < indl.size(); i++) indl[i] = comp_l[indl[i]];
    for (int i = 0; i < indr.size(); i++) indr[i] = compr[indr[i]];



    vector<int> ansl(arr.size() + 1), ansr(arr.size() + 1);

    //cout << "4 " << l << " " << r << endl;

    solve(l, m, arr1, ansl);
    //cout << "5 " << l << " " << r << endl;
    solve(m, r, arr2, ansr);
    //cout << "6 " << l << " " << r << endl;

    int best = INF;
    for (int i = 0; i < arr.size(); i++) {

        if (usedl[comp[i]] && usedr[comp[i]]) {
            ans[comp[i]] = ansl[indl[comp[i]]] + ansr[indr[comp[i]]];
        }
        else if (usedl[comp[i]]) {
            ans[comp[i]] = ansl[indl[comp[i]]] + ansr[0];
        }
        else {
            ans[comp[i]] = ansl[0] + ansr[indr[comp[i]]];
        }
        best = min(best, ans[comp[i]]);
    }

    ans[0] = min(ansl[0] + ansr[0], best + 1);
    for (int i = 0; i < arr.size(); i++) {
        ans[comp[i]] = min(ans[comp[i]], best + 1);
    }

    /*for (int i = 0; i <= comp.back(); i++) {
        cout << i << " " << ans[i] << endl;
    }*/
}

int main() {
    //freopen("in.in", "r", stdin);

    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int k, n, m;
    cin >> k >> n >> m;

    int lst = 0;
    for (int i = 0; i < n; i++) {
        Seg seg;
        int len, c;
        cin >> len >> c;
        seg.l = lst;
        seg.r = lst + len;
        seg.c = c;
        arr.push_back(seg);

        lst += len;
    }
    sort(arr.begin(), arr.end(), [](Seg s1, Seg s2) {return s1.c < s2.c; });

    vector<int> ans(n + 10);
    solve(0, (1<<k), arr, ans);

    cout << ans[0] << endl;

    return 0;
}
